\documentclass{tortechrep}
\usepackage{url}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{longtable}
\usepackage{paralist}
\usepackage{comment}

%\usepackage{styles/pdfdraftcopy}
%\draftcolor{gray20}
%\draftstring{DRAFT}
%\draftfontsize{150pt}

\begin{document}

\title{Hidden-service statistics reported by relays}

\author{David Goulet\\The Tor Project\\ \href{mailto:dgoulet@torproject.org}{dgoulet@torproject.org} \and
Aaron Johnson\\U.S. Naval Research Laboratory\\ \href{mailto:aaron.m.johnson@nrl.navy.mil}{aaron.m.johnson@nrl.navy.mil} \and
George Kadianakis\\The Tor Project\\ \href{mailto:asn@torproject.org}{asn@torproject.org} \and
Karsten Loesing\\The Tor Project\\ \href{mailto:karsten@torproject.org}{karsten@torproject.org}}
%\footnotemark[\ref{tpi}]

\reportid{2015-04-001%
\footnote{This material is based upon work supported by the National
Science Foundation under Grant No.\ CNS-1111539.
Any opinions, findings, and conclusions or recommendations expressed in
this material are those of the author(s) and do not necessarily reflect
the views of the National Science Foundation.}}
\date{April 28, 2015}

\maketitle

% Text conventions
%  - Each sentence ends with a newline, even inside a paragraph.
%  - Lines are at most 74 characters wide.
%  - Abbreviations are best avoided.
%  - Code, cell names, etc. are put inside \verb+...+.

%\tableofcontents

\begin{abstract}
In order to understand how hidden services are being used in Tor, relays
can collect and report statistics about the hidden-service activity they
observe. However, such statistics might harm the privacy of individual Tor
users. We describe how relays can be used to collect statistics about
hidden services, how they might be useful, and how they can be published
in a way that protects individual privacy.
\end{abstract}

\section{Introduction}

Tor hidden services~\cite{tor-design,rend-spec} are a means to provide a
network service while hiding the location of the server. To provide this
anonymity to the server, client connections are set up using a different
process than is used by connections to known servers. This process comes
with a performance cost. Also, servers must be configured explicitly to
be accessed as a hidden service. As a result, the way that Tor hidden
services are being used may be quite different from the way that Tor is
used to anonymize traffic to normal, non-hidden Internet services.

Therefore, in addition to the general statistics that Tor collects
about its network~\cite{tormetrics}, it is interesting and useful to 
collect statistics specific to hidden services. For example,
hidden-service statistics could show how popular they are, how well they
perform, and if they are under attack. Publishing such data could help
Tor to manage and improve its network, Tor advocates to argue more
effectively in support of Tor, and researchers to understand how Tor is
being used.

Tor relays are frequently in a position to learn some information about
hidden services and their usage. Relays have long collected and reported
information for many \emph{general} statistics of interest (i.e.
those that are not specific to hidden services), such as the amount of
total traffic that they have relayed. They do this by including these data
in ``extra-info documents''~\cite{dir-spec}, which
are uploaded to the Directory Authorities. These local observations can be
combined to give a global view of Tor's hidden service activity.

However, Tor's privacy protections depend on relays not sharing all their
local observations. Therefore, we must carefully consider how to publish
data in a way that doesn't hurt Tor's privacy goals. Tor has adopted
some privacy protections for the general statistics it gathers. These 
protections include
reporting data aggregated over a period of time and rounding some
measurements to a desired level of accuracy. There is a set of privacy
objectives and risks that are specific to hidden services, however, and so
these techniques may not apply directly.
For example, hidden services have a primary privacy goal of hiding the
server's location and a secondary goal of allowing the existence of the
service itself to be hidden.

% more detail / a paragraph about obfuscation techniques?
Thus, to address the particular challenge of studying Tor hidden services,
this report describes how relays can safely collect useful statistics
about them. It includes the following contributions:
\begin{itemize}
\item A description of the types of observations that relays can make
about hidden services
\item A description of the privacy objectives specific to hidden services
\item A description of obfuscation techniques that can be used to safely
release hidden-service statistics
\end{itemize}

\section{Hidden-service protocol and measurement points}
\label{sec:protocol}

The hidden-service protocol consists of multiple steps for a service to
become available through the network and for a client to connect to a
service~\cite{rend-spec}. Each step gives some relays the opportunity to
gather statistics about their role in the hidden-service
protocol. Hidden service clients and servers also are in a position to
gather statistics, but in this report we focus on collection by relays.
The major roles of relays in the hidden-service protocol are: a) Hidden
Service Directory (HSDir), b) Introduction Point (IP), and c) Rendezvous
Point (RP). Figure~\ref{fig:protocol} gives an overview of protocol steps.

\begin{figure}
\centering
\includegraphics[width=0.8\textwidth]{protocol.pdf}
\caption{Hidden-service protocol steps as observed by relays}
\label{fig:protocol}
\end{figure}

The protocol steps for making a service available through the network are
as follows:

\begin{enumerate}
\item The service \emph{establishes an Introduction Point} on one or more
relays.
A relay first receives a circuit extension request from another relay to
become the next relay in a circuit.
At this time the relay does not recognize that it will become an
Introduction Point.
Then the relay receives a request to establish an Introduction Point on
behalf of the service that built the circuit.
However, the Introduction Point does not know which service it's serving,
because the service creates a fresh identity key for each Introduction
Point.
The circuit, now called introduction circuit, will be kept open until the
service closes it.
From that time on the relay accepts client introductions for the service
coming in via other circuits.
\item The service \emph{publishes a descriptor} to a total number of six
Hidden Service Directories, which are the set of relays with high-enough
uptime as indicated by the ``HSDir'' flags in the network consensus.
Each of those relays receives a circuit extension request followed
by a request to publish the descriptor.
The relay can read most parts of the descriptor, including the service
identity (this may change as part of a proposed protocol
update~\cite{torprop-rend-spec-ng}) and selected Introduction Points.
The circuit that was built by the service is closed immediately after
transmitting the descriptor.
\end{enumerate}

The protocol steps for a client connecting to a service are as
follows:

\begin{enumerate}
\setcounter{enumi}{2}
\item The client \emph{fetches a descriptor} from a Hidden Service
Directory. The relay that acts as an HSDir receives a circuit extension
request followed by a request to fetch the descriptor.
Once the descriptor is returned, or a response is returned saying that the 
descriptor does not exist, the circuit is closed immediately.
\item The client \emph{establishes a Rendezvous Point} on a relay.
The relay observes a circuit extension request, followed by a request to
become the client's Rendezvous Point for connecting to a service.
The relay does not learn which service the client attempts to connect to,
only a random identifier.
The circuit, now called rendezvous circuit, is kept open until either
the client or service closes it.
\item The client \emph{sends an introduction} to one of the service's
Introduction Points.
The Introduction Point observes a circuit extension request
followed by the introduction message, which it forwards to the service via
its introduction circuit.
The client's circuit is torn down by the relay after receiving the
introduction and responding with an acknowledgement.
\item The service \emph{sends a rendezvous message} to the client's
Rendezvous Point.
The Rendezvous Point sees a circuit extension request followed by the
rendezvous message, which it forwards to the client via its rendezvous
circuit.
Both service-side and client-side circuits are kept open until either side
decides to close it.
\item Both \emph{client and service send and receive data} along their
part of the rendezvous circuit.
The Rendezvous Point sees cells coming in from either side and forwards
them to the other side.
All cells are padded and end-to-end encrypted between client and service,
so that the Rendezvous Point only sees encrypted cells of the same size.
\end{enumerate}

All of these protocol steps constitute potential measurement points for
hidden-service related statistics. For example, some Tor relays have
been reporting the following statistics about hidden services, which
were proposed by Kadianakis et al.~\cite{torprop-hsstats} and the
results analyzed by Kadianakis and
Loesing~\cite{extrapolation-tor-techreport}:
\begin{compactenum}
\item \textsf{NumRPCells}: The number of hidden-service data
cells seen at a Rendezvous Point, reported every 24 hours
\item \textsf{NumHSDirIDs}: The number of unique hidden
identifiers seen at an HSDir, reported every 24 hours
\end{compactenum}

\section{Evaluation criteria for statistics}
\label{sec:criteria}
A proposal to collect some hidden-service statistics must be evaluated
according to several criteria. The main criteria are the benefits to Tor,
the effect on privacy, the reliability of the statistics, the efficiency
of the collection process, and alternatives to live collection.

\subsection{Possible benefits from gathering statistics}
There are several compelling reasons to collect information about hidden
service statistics. We describe some of them to illustrate the possible
benefits.

\paragraph{Learn about usage}
Understanding how hidden services are being used can help both to direct
development efforts and to justify them. Usage statistics could provide
insight into how many hidden services exist, how available they are, how
many clients they have, how much Tor traffic is hidden-service traffic,
and what types
of applications use hidden services. These data could help Tor developers
decide how much effort to spend improving hidden services and what types
of changes would most benefit users. They can also be of use to
researchers that analyze Tor and design improvements.
Hidden-service statistics would also provide evidence
that can be used in efforts to improve their media coverage,
to persuade potential funders, and to inform government policy.

\paragraph{Improve performance}
Data about hidden services can help Tor developers improve performance.
Such data might include speed and failure rates for the steps of the
hidden-service protocol, resource utilization at the relays, and
hidden-service availability.
This information could be used to improve load balancing across relays,
to optimize the values of various parameters in the hidden-service
protocol, and to add relay resources where they would be most effective.
They could be used to inform more ambitious redesigns of the
hidden-service protocols. They could also be used to build models of
client, network, and hidden-service behavior to use in network simulations
done in support of performance improvements.

\paragraph{Identify bugs}
Statistics can help detect bugs in hidden services. This could be
especially useful to identify problems those that occur infrequently or
only under realistic conditions, such the network traffic load or the mix
of Tor software versions used. Information that could be particularly
useful for this purpose includes failures rates and the frequency of
unexpected events.

\paragraph{Discover attacks}
Hidden-service statistics may uncover ongoing attacks in the network.
Denial-of-service attacks in particular might be detected from spikes in
usage and failure statistics. Statistics about the utilization of relay
resources such as CPU, memory, and bandwidth might also reveal variations
that are unexpected under normal use. In addition, data about the software
versions may reveal client Sybil attacks or botnet
abuse~\cite{botnetfc14}.

\subsection{Hidden-service privacy goals}
Gathering statistics on Tor has implications for its privacy because the
data is determined from relays' observations of the private behavior of
Tor users. Tor statistics are published and thus may be used by an
adversary to determine the private activity of Tor users.

Tor has several privacy goals. Primary, of course, is to provide
anonymity to the source of a connection and to hide the network location
of a hidden service. However, there are several
other related and secondary goals. Complementing user privacy, for
example, is the goal of unlinkability among separate Tor connections,
which prevents an adversary from creating a pseudonymous profile
of a user's network activity. We focus on the various privacy goals
specific to hidden services, which to our knowledge have not previously
been explicitly articulated. Our listing of privacy goals is not
exhaustive. Tor's default position for information about the use
of its network is that it should be protected, and exceptions should be
made only in specific, carefully-considered cases. The privacy goals we
highlight are those for which choosing to contradict them is very
unlikely.

\paragraph{Information about a specific hidden service}
The following information about any specific hidden service should remain
private:
\begin{compactenum}
\item The network location of the hidden service
\item The exact number of hidden services (i.e. the existence of the
hidden service)
\item The number of clients that have used the hidden service
\item The number of connections to the hidden service
\item The amount of traffic to or from the hidden service
\item The availability of the hidden service
\end{compactenum}
Observe that including several of these amounts to a goal of allowing a
hidden service to remain undiscovered or undistinguished. This allows a
hidden service to maintain a low profile and not come under investigation
or scrutiny by an observant adversary.
Also note that these are not all currently well-protected by Tor. For
example, the existence and popularity of a hidden service can currently be
learned by an HSDir~\cite{oakland2013-trawling}, although there are plans
to close this information leak~\cite{torprop-rend-spec-ng}. 

\paragraph{Information about a specific hidden-service client}
Related to the above, it is a goal to hide information that is specific
to a given hidden-service client, including
\begin{compactenum}
\item The number of hidden-service connections of the client
\item The amount of the client's hidden-service traffic
\item When a client is active on hidden services
\end{compactenum}
These privacy goals also exist more generally for clients' Tor activity
that doesn't use hidden services.

\paragraph{Information about a specific hidden-service connection}
It is also a goal to hide information about any given hidden-service
connection, including
\begin{compactenum}
\item The client and the service of the connection
\item The exact number of hidden-service connections
\item When a connection occurred
\item How much traffic was transferred over some connection
\item If the connection shares a client or hidden service with another
given connection
\end{compactenum}
As with specific client information, it is a privacy goal more generally
to protect information about any specific client connection.

\paragraph{Information about ongoing activity}
Statistics should not reveal information relevant to the \emph{ongoing}
activity of clients, hidden services, or connections. This should be
maintained even when the information is safe to release \emph{after} the
activity has ceased. For example, it should not be revealed that certain
relays are currently being used as Introduction Points by some hidden
service, although it may be reasonable to reveal that some relays have
been used as Introduction Points in the past. The risk of revealing
ongoing activity is that an active adversary can use that information
to begin targeted surveillance of that activity.


\subsection{Reliability}
An important criterion for a statistics-gathering procedure is its
reliability. To be reliable, data must be accurate, available, robust to
network changes, and resilient to malicious attacks. This criterion
becomes especially important when a statistic affects the operation
of Tor in real time. For example, the measurements gathered by
TorFlow~\cite{torflow-hotpets10} are used to determine relay weights
in the hourly consensuses.

Robustness to future network changes is an important concern in the Tor
network, which frequently improves in response to user needs and
adversarial capabilities. For example, there are several current
proposals to change hidden services in
minor~\cite{torprop-hsdir-stable,torprop-tor2web} and
major~\cite{torprop-rend-spec-ng} ways.
Statistics collection shouldn't be broken or precluded by such
protocol changes.

Malicious attacks are another particular concern for Tor, because it
operates in a highly-adversarial setting that is not typical of many other
networks and services. When relays collect and report hidden-service
statistics, the process is particularly vulnerable to manipulation
by malicious relays, which can provide completely arbitrary data. An
ideal procedure for gathering statistics would be robust to attempted
manipulation by a small fraction of the network.

\subsection{Efficiency}
Statistics collection should not place an undue burden on Tor's existing
infrastructure. It should be designed to minimize bandwidth consumption,
CPU utilization, and memory requirements. Thus it may be necessary to
limit the frequency at which statistics are updated or the complexity of
a cryptographic aggregation
procedure~\cite{elahi-ccs2014,privda-acsac2014}.

\subsection{Alternatives}
Some of the possible benefits of measuring the live Tor network may
also obtained by measuring private or
simulated~\cite{shadow-ndss12,sukhbir-thesis} networks. For example,
private networks can be used to find bugs by testing hidden services under
various conditions and looking for unexpected behavior. Using these
methods eliminates the privacy risk that accompanies measurement of the
live network, and so such methods should be preferred when possible.

\begin{comment}
\section{List of hidden-service related statistics}
\label{sec:list}

%\textbf{The descriptions in this section have not been updated yet.  Let's
%wait with cleaning them up until we have a final list of statistics and a
%final section structure.  Otherwise we'd be rewriting this section over
%and over and over.}

In this section we attempt to compile a comprehensive list of
hidden-service related statistics.
We start with general circuit related statistics, statistics on
successfully advertised services and successful service usage,
performance-related statistics, and finally discuss statistics on protocol
failures.

Not all of the following statistics provide an actual benefit towards
making hidden services better, and some statistics are outright dangerous
and should never be deployed in the public Tor network.
However, they are all worth being listed here, if only to have a reference
for the future that says \emph{why} they are a bad idea.

\subsection{General hidden-service circuit related statistics}

We start with statistics that are not specific to the three roles of
relays in the hidden-service protocol, but that apply to all of them.

\subsubsection{Time from circuit extension to circuit purpose change} 
\label{subsubsec:time_circ_ext_to_purpose_change}

% (the following distinction cannot be made, AFAIK.  here's what happens:
% we receive a CREATE (?) cell from another relay that establishes the
% circuit to us, and then we receive an ESTABLISH_INTRO cell.  if the time
% difference between those two events is small, we can guess that the
% client built a new circuit for using us as introduction point, or that
% she extended an existing circuit by one hop to do so.  if the time
% difference is more than, say, a second, we can guess that the client
% created this circuit a while ago and only recently decided to
% cannibalize it and use it as introduction circuit.  statistics would
% tell us what fraction of circuits is newly built and what was
% cannibalized; well, allow guesses about the two cases.)
%
\textbf{Details:}
%
A relay measures the time difference between a circuit extension from the
previous relay in the circuit to receiving an \verb+ESTABLISH_INTRO+ cell.
A very small time difference implies that the circuit was built/extended
specifically for use as introduction point, whereas a larger time
difference hints to the hidden service re-using a pre-built circuit for
the introduction point.
%
% [dgoulet]: "if the time difference between those two events is small, we
% can guess that the client built a new circuit for using us as
% introduction point, or that she extended an existing circuit by one hop
% to do so" -- I think it should be that if the time difference is small,
% one can assume a cannibalized circuit else a new circuit.
% [karsten]: it might be that we're thinking of different things when we
% say cannibalizing a circuit.  here are three possible cases, from the
% perspective of a client/service:
%   - create, extend, extend, ............. wait .................,
%   establish introduction point   ->   large time difference observed by
%   last relay
%   - create, extend, extend, ............. wait ........., extend,
%   establish introduction point   ->   small time difference observed by
%   last relay
%   - create, extend, extend, establish introduction point
%   ->   small time difference observed by last relay
%  which of these do you call cannibalized?  (I'm not sure what the code
%  says here.)
% [dgoulet]: To be honest not sure which one is right but what I can see
% from the code is that a client circuit can be cannibalized for the
% introducing part which is extended with an extra hop. Now the way I see
% it is that there is probably a noticable time difference between using
% an already created circuit for which we simply extend one hop versus
% establishing a new one of 4 hops.
% [karsten]: That's right, but we have no data from the client, but only
% from the relay that happens to be the last hop in the circuit.  That
% relay only sees that the circuit gets extended to it, but it has no
% information how long the client had the circuit lying around before
% extending it.
%
%
% Newly established circuit.
% Benefits: Performance reason, this can be useful to know the real cost
% (on average) of becoming an IP. Can lead to understanding bottle necks
% across the network or maybe identify relay that are misbehaving.
% Risks: That can be tricky. Having a specific time frame on a circuit
% establishment can maybe lead to some traffic correlation.
% Cannibalized circuit.
% Benefits: Performance reason, we can see if cannibalizing a circuit is
% actually a gain from a new one. This value also could tell us what's the
% fraction of circuit that are cannibalized and the net performance gain
% of that which could lead to maybe better heuristic on choosing/creating
% circuit to be cannibalized.
% Risks: Also tricky. That info could tell us clearly if the IP circuit is
% on a new or already established circuit which changes the traffic
% timing. Not sure how useful it is to an attacker though.
\\
\textbf{Benefits:}
%
We would learn what fraction of introduction points can be established on
short notice using pre-built circuits vs. first having to build or extend
circuits.
This is something we would measure on hidden services, but given that we
don't have statistics from those, measuring this on introduction points
seems like a fine workaround.
%
% Both of these stats should probably report an average and a variance
% instead of a <timestamp> + <circ. creation time>, that would be a
% disaster.  (yes, please, no data about single events; that wouldn't fit
% into descriptors anyway, and it would reveal far too much detail.)
% I really wonder if an attacker could use this average to partition part
% of the network to predict where the circuit can be located?
%
The time from receiving a circuit creation request to seeing the
\verb+ESTABLISH_RENDEZVOUS+ cell can help us optimize the rendezvous
protocol for performance.
The current implementation either builds a new circuit or extends an
existing circuit by one hop before sending the \verb+ESTABLISH_RENDEZVOUS+
cell.
So, the measured time will be close to zero.
But if we ever decide to re-use existing circuits for rendezvous without
extending them by another hop, this metric will give us an idea on the
adoption of that change.
%Admitted, this benefit is not huge.
\\
\textbf{Risks:}
%
No obvious risks.  % only talking about aggregate statistics here, not
% single observations.

% [dgoulet]: Reporting a mean/average and with maybe a treshold before we
% publish like "we need 100 rdv cell before reporting this stat" ?
% [karsten]: agreed that this may seem useful in general.  but what if the
% adversary sends 100 cells themselves to help us get past the threshold
% and report a tiny number of actual user cells?  but I added an item to
% the section start where we can discuss whether this is a good safeguard
% in general.
% [dgoulet]: Right well that's a time statistic and not an amount so if an
% attacker would establish 100 RP I guess he/she indeed poisoning the
% stat?...
% [karsten]: Maybe.  In theory, the stat is not poisoned for the attacker
% if she knows what values she's contributed to it.  But I agree that this
% is not the best example.

\subsubsection{Number of circuits built with TAP vs. nTor}
\label{subsubsec:num_circ_tap}

\textbf{Details:}
%
Older clients (0.2.3.x) would build/extend circuits using TAP, newer
clients would use nTor for that.
Relays can report the number of introduction circuits that were built
using either of the two methods.
More precisely, relays would remember for each circuit how it was built,
and as soon as they receive an \verb+ESTABLISH_INTRO+ cell, they increment
one of two counters.
See ticket 13466 for details.
\\
\textbf{Benefits:}
%
We would learn what fraction of clients and what fraction of services run
older tor versions (0.2.3.x or older).
\\
\textbf{Risks:}
%
As tor-0.2.3.x gets less common and only a few hidden services still
use it, an adversary would be able to track their introduction points
by checking which relays still report TAP clients on their statistics.

\subsubsection{Time from circuit purpose change to tearing down circuit}
\label{subsubsec:time_circ_purpose_change_to_teardown}

\textbf{Details:}
%
Relays report how long it takes from changing the purpose of circuit to a
hidden-service specific purpose to tearing down the circuit.
This statistic only makes sense for circuits which are only built for
sending a single message, which includes services publishing descriptors,
clients fetching descriptors, and clients sending introductions.
In theory, we would expect the circuits to be torn down immediately, but
in practice circuits might be kept open longer.

\subsection{Statistics on service advertisement}

The following statistics are all about (successful) service advertisement.
Performance-related statistics and failure statistics are covered in a
later section.

\subsubsection{Number of established introduction points}
\label{subsubsec:num_establish_ip}

\textbf{Details:}
%
A relay counts how many \verb+ESTABLISH_INTRO+ cells it receives and acts
upon during the statistics interval.
\\
\textbf{Benefits:}
%
We could validate that we have a ``uniform'' random distribution among
chosen introduction points in the network.
If not, there might be a problem. This could also be used to count the
number of introduction points actually being used by hidden services,
which could reveal errors or non-standard usage.
\\
\textbf{Risks:}
This could reveal the introduction points of hidden services with
encrypted descriptors.

\subsubsection{Time from establishing introduction point to tearing down
circuit}
\label{subsubsec:time_intro_to_teardown}

\textbf{Details:}
%
How long did an introduction circuit last?
Relays would report statistics like mean/median time, variance/IQR, and/or
percentiles here.
\\
\textbf{Benefits:}
%
The longer introduction circuits last, the better, from a performance POV.
If many circuits break after a short time period, that indicates that
services should attempt to make better path-selection decisions for
building introduction circuits.
This statistic can also be used to analyze what fraction of services is
available for a short time only, and what fraction is available most of
the time.

\subsubsection{Number of hidden service descriptors seen by directory}
\label{subsubsec:num_descriptor_publish}

\textbf{Details:}
%
Relays keep a local count of cached hidden-service descriptors.
Every time they add or remove a descriptor to their cache, relays update
their counter and record the time of change.
At the end of the statistics period they calculate statistics like
minimum, maximum, average number of hosted descriptors during the
statistics interval.
(There may be more efficient ways to implement these statistics that avoid
keeping a full history with timestamps, which are not discussed here.)
\\
\textbf{Benefits:}
%
This is an interesting statistic that would allow us to understand how
used hidden services are, and also detect sudden changes in the number of
services (botnets, chat protocols, etc.).
Also, learning the number of hidden services per directory will help us
find bugs in the hash ring code and also understand how loaded directories
are.
\\
\textbf{Risks:}
%
Publishing this stat would allow someone who is indexing hidden services
to be able to say ``I have seen 76~\% of all hidden services''.
We would really like to avoid having such an enumeration-facilitating
property.
%We could be persuaded that with some heavy stats obfuscation (heavier than
%the bridge stats obfuscation), this statistic might be plausible.
%By statistics obfuscation, we mean obfuscating the numbers so that the
%attacker can only say ``I'm somewhere between 60~\% to 75~\% of all
%HSes.''.
%This is a bit related to differential privacy as we understand it, but
%much more basic.
Obfuscation will be necessary to prevent this (see
Section~\ref{sec:obfuscation}).

Another risk is that changes in the number of HSes could reveal patterns
in the services over time. For example, it could reveal some services that
are published during certain times of day and certain days of the week,
which could correlate with daylight hours and/or working days in certain
parts of the world. This information could also be correlated with
network outages over time to narrow down the location of hidden services.
\\
\textbf{Notes:}
%
When \verb+rend-spec-ng.txt+\cite{torprop-rend-spec-ng} gets implemented, it will
be harder for
hidden service directories to learn the number of served services
since the descriptor will be encrypted.
However, directories will still be able to approximate the number of
services by checking the amount of descriptors received per publishing
period.
If this ever becomes a problem we can imagine publishing fake
descriptors

\subsubsection{Number of descriptor updates per service}
\label{subsubsec:num_decriptor_updates}

\textbf{Details:}
%
Relays count how many descriptor updates they see per service.
Assuming that stats are published daily (which is not necessary), this is
going to be a number between 1 and 24 (since RendPostPeriod is currently
one hour) and services pick a new directory after 24 hours (see
\verb+rendcommon.c:get_time_period()+).
\\
\textbf{Benefits:}
This could reveal overall HS descriptor stability, which reflects
the frequency of events causing descriptor updates, such as changing
IPs or changing authentication keys. Also, this could reveal client errors
or DoS attacks on HSDirs.
\\
\textbf{Risks:}
%
Depending on how many HSes are behind each HSDir, this statistic might or
might not reveal uptime information about specific services.
Still it doesn't seem like something we want to risk.
Also, if the result is greater than 24, it means that an HS with modded
RendPostPeriod was publishing to that HSDir (and that the HSDir doesn't
have many clients).
%Do we want to reveal that?
%OTOH, it seems to me that if the directory is serving many services, this
%statistic doesn't really provide any insight.
In addition, this could
be used to reveal the introduction points used by a hidden service
(assuming its address is known, but its descriptors are encrypted) by
DOSing suspected IPs and observing in the responsible HSDirs report
a higher number of descriptor updates.

\subsubsection{Time between last and first published descriptor with same
identifier}
\label{subsubsec:time_first_last_descriptor_update}

\textbf{Details:}
%
Relays report statistics on the time difference between the last and the
first descriptor published under the same identifier.
This statistics indicates service uptime, because a service with high
uptime would periodically re-publish its descriptor whenever its
introduction points change.
There is an upper bound on this statistic at 24 hours, because that's when
descriptor identifiers change.

\subsubsection{Number of introduction points contained in descriptors} \label{subsubsec:num_ips_in_descriptors}

\textbf{Details:}
%
Relays report average number of introduction points contained in
hidden-service descriptors, possibly also percentiles.
\\
\textbf{Benefits:}
%
It would be interesting to know whether services deviate from the default
number of introduction points.
Though it's unclear what we're going to do with this information.
This statistic will also be killed by rend-spec-ng~\cite{torprop-rend-spec-ng}.

\subsubsection{Number of descriptors with encrypted introduction points
(3.1.5.)} \label{subsubsec:num_desc_encrypted_ips}

\textbf{Details:}
%
Relays can look at published hidden-service descriptor and count
descriptors with plain-text vs. encrypted introduction point sections.
\\
\textbf{Benefits:}
%
We would learn what fraction of services uses authentication features.
This statistic won't be available after implementing
rend-spec-ng~\cite{torprop-rend-spec-ng}.

\subsection{Statistics on service usage}

The following statistics are about service usage, where
performance-related statistics and failure statistics are covered at a
later time.

\subsubsection{Number of descriptor fetch requests}
\label{subsubsec:num_desc_fetches}

\textbf{Details:}
%
A relay reports the total number of descriptor fetch requests, regardless
of the requested hidden service identity.
\\
\textbf{Benefits:}
This statistics would be an indication of the amount of client HS
activity. It would complement the statistics counting rendezvous data
cells by indicating the number of ``initial'' connections rather
than the amount of data, which should be a better estimate of the
number of unique user-service pairs.
\\
\textbf{Risks:}
%
An adversary could use this statistic to evaluate the popularity of a
known HS because the HSes set of HSDirs would likely be unique and also
known. The adversary could remove from the reported counts the fetches
for other HSes sharing the individual HSDirs by identifying by how much
the counts of a given HSDir tend to change during the periods for which
the target HS is assigned to them.
This is a major problem that doesn't seem resolvable without some kind
of anonymization or private aggregation of the per-relay stats (see
Section~\ref{sec:obfuscation}).

\subsubsection{Number of descriptor fetch requests by service identity} \label{subsubsec:num_descriptor_fetches_per_hs}

\textbf{Details:}
%
Relays report the distribution of descriptor fetch requests to hidden
service identities.
%
\textbf{Benefits:}
This statistic would have the same benefits
as~\ref{subsubsec:num_desc_fetches}, as well as being informative
about HS usage. For example, it could reveal if there are many
moderately-popular HSes or just a few very popular ones.
\\
\textbf{Risks:}
This statistic would have the same risk
as~\ref{subsubsec:num_desc_fetches}, as well as potentially
making it even easier to reveal per-HS popularity. For example,
if the statistic reported the maximum number of fetches over all
HSes, and it was already clear which HS was the most popular,
then this statistic could give that adversary an exact measure
of popularity.
%

\subsubsection{Number of established rendezvous points}
\label{subsubsec:num_rps}

\textbf{Details:}
%
Relays report how many \verb+ESTABLISH_RENDEZVOUS+ cells they received.
\\
\textbf{Benefits:}
%
The number of received \verb+ESTABLISH_RENDEZVOUS+ cells indicates how
many connection attempts there are by clients to services that are
running.
This number is different from the number of descriptor fetches which
happen when clients don't know yet whether a service is running, which
will be omitted if clients still have a descriptor cached from a previous
connection, and which we may not even gather because of privacy concerns.
We can easily weight the number of \verb+ESTABLISH_RENDEZVOUS+ cells with
the probability of choosing a relay as rendezvous point to estimate the
total number of such cells in the network.
\\
\textbf{Risk:}
%
There is no obvious risk from sharing this number if aggregated over a
large enough time period.

\subsubsection{Number of introductions received from clients}
\label{subsubsec:num_intros_from_clients}

\textbf{Details:}
Relays report how many \verb+INTRODUCE1+ cells they received from clients.
\\
\textbf{Benefits:}
This indicates that there is in fact a client trying to reach a hidden
service thus the amount of cells could give us a rough estimate of how
many clients are actually connecting and using hidden services.
\\
\textbf{Risks:}
An adversary could use this statistic to learn the number of attempted
connections to a known HS. To do this, the adversary would fetch a 
descriptor for the HS, learn the introduction poins for the HS,
and then observe how many \verb+INTRODUCE1+ cells were received by
those relays. To remove connections due to other HSes sharing the same
IP, the adversary could observe the counts over the (almost certainly
unique) set of IPs and identify how these counts differ from other
relays not used by the target HS and from the same relays in periods
for which they don't serve as IPs for the target HS.
This statistic may require anonymization or private aggregation techniques
to avoid this problem.

% [dgoulet]: I think, after discussing it with Nick, that this might be OK
% if the relay reports this stat for a lot of HS meaning the relay has at
% least been an IP for multiple HS thus this stat can't be correlate to
% one specific HS. Now, the period here can be difficult to get right.
% RendPostPeriod is at 1 hour but is the HS actually changes the IP set
% every upload period? If yes, that means that over let say 24 hours, that
% INTRODUCE1 cell could potentially more than one HS which seems to me ok.
% Might be still dicy if wrongly implemented.
% [karsten]: this is also a fine question, not limited to this statistic;
% which is why I moved it to the section start, too.  but I'm unclear what
% this has to do with RendPostPeriod.  servers don't create a new set of
% introduction points every hour, AFAIK.
% [dgoulet]: No they don't, I confirmed in the code.

\subsubsection{Number of introductions received by established
introduction point} \label{subsubsec:num_intros_per_circ}

\textbf{Details:}
%
Relays can serve as introduction point for an arbitrary number of hidden
services.
Relays could report statistics (like percentiles) on received
\verb+INTRODUCE1+ cell by introduction circuit.
\\
\textbf{Benefits:}
%
This statistic would tell us something about usage diversity of hidden
services.
A special case would be the number or fraction of established introduction
points that never sees a single \verb+INTRODUCE1+ cell.
It's unclear what we'd do with this information, though.
\\
\textbf{Risks:}
This shares the same risks as \ref{subsubsec:num_intros_from_clients} but
potentially makes it even easier to differentiate introductions due to
different HSes with the same IP.
%

\subsubsection{Number of server rendezvous}
\label{subsubsec:num_server_rendezvous}

\textbf{Details:}
%
Relays report the total number of \verb+RENDEZVOUS1+ cells they receive.
\\
\textbf{Benefits:}
%
The number of received \verb+RENDEZVOUS1+ cells tells us how many
connection requests are actually accepted by servers.
This number may be lower than the number of \verb+ESTABLISH_RENDEZVOUS+
cells, because of failures in connection establishment, authentication
failures, or other reasons.
\\
\textbf{Risks:}
%
There is no obvious risk from this metric, because it's unrelated to any
given client or server.

% [dgoulet]: Wondering if there is a real benefit here? I guess if we see
% 100 RENDEZVOUS1 and onlye *one* ESTABLISH_RENDEZVOUS, that might signal
% an issue... ?
% [karsten]: the idea is that things can go wrong between establishing a
% rendezvous point and the server sending a rendezvous.  knowing what
% fraction of established rendezvous are actually used tells us something.
% and I think you mean 1 RENDEZVOUS1 and 100 ESTABLISH_RENDEZVOUS in your
% example.  because 100 RENDEZVOUS1 for a single ESTABLISH_RENDEZVOUS
% would for sure look funny.
% [dgoulet]: well either way, it's an issue :)... If the HS sends a big
% amount of RENDEZVOUS1 to Alice's RP for which Alice only created one RP
% (one  ESTABLISH_RENDEZVOUS), that's quite an issue (loop that went wrong
% :).


\subsubsection{Number of cells sent over rendezvous circuits in either
direction} \label{subsubsection:num_cells_rend_circ}

\textbf{Details:}
%
Relays report the number of \verb+RELAY+ cells sent in either direction.
\\
\textbf{Benefits:}
%
The number of \verb+RELAY+ cells sent by either client or server can give
us a detailed view on hidden service usage.
In contrast to common Tor usage, there is no point in the rendezvous
protocol where we could count transferred bytes.
The number of cells is the best approximation that we have.
In addition to the total number of cells, the number of cells by direction
can indicate how common classical client-server protocols are compared to
peer-to-peer models.
As a special case, we'd want to know what fraction of circuits has zero
\verb+RELAY+ cells, which would indicate a connection problem late in the
process.
\\
\textbf{Risks:}
%
In contrast to the cells discussed above, \verb+RELAY+ cells contain
actual user content.
The pattern of \verb+RELAY+ cells could also be used to fingerprint a
given server or even client. Even more simply, this statistic could
reveal the mere existence of an HS connection, especially a large one,
which the adversary might otherwise not be aware of. This could combine
badly with background knowledge such as the following: the adversary
observes at the user's ISP a certain large amount of traffic from a user
that he suspects might be hidden-service traffic. If he observes an
increase in this statistic by about the same amount, he can infer that
the user was indeed using hidden services.
While total number of cells by direction aggregated over a certain time
period should be okay to measure, any statistics going further than that
need closer analysis.

\subsubsection{Time from first client data to tearing down circuit} \label{subsubsec:time_client_data_to_teardown}

\textbf{Details:}
%
Relays report the time from seeing the first \verb+RELAY+ cell sent by the
client to tearing down circuit by either client or server.
\\
\textbf{Benefits:}
%
The time between receiving the first \verb+RELAY+ cell to tearing down the
circuit indicates typical session length of hidden service connections.
We'd be able to say whether typical hidden-service connections are rather
short-lived or long-lived.
This information may help us make educated guesses on the type of
applications run over hidden services.
It may also help us improve the selection criteria for rendezvous points.
\\
\textbf{Risks:}
%
Session length is quite sensitive data that could be correlated with
circuit lifetimes at other places in the network.
Fortunately, the rendezvous point is neither specific to any given client
or service, which makes this information slightly less sensitive.
However, if, for example, the adversary knows that a user maintained some
network activity for a specific amount of time and then observes a relay
report in this statistic that someone used a rendezvous connection
for that long, then he could infer that the target user was using hidden
services. This gets worse if the adversary makes observations over time
and can observe the changes in the resulting statistics.

% How many rendezvous requests finally succeded?
% Opposite: What percentage of the time did the rendezvous fail to happen?
% (rendezvous can fail at different steps.  one way to count failures is
% to compare number of ESTABLISH_RENDEZVOUS, RENDEZVOUS1, and subsequent
% RELAY cells.)
% How much time did it take to splice the RP circuit? (#13194)  (you mean
% time from RENDEZVOUS1 to first RELAY cell?)

\subsubsection{Number of closed rendezvous circuits without a single data
cell} \label{subsubsec:num_rend_circ_no_data}

\textbf{Details:}
%
Relays report the number of rendezvous circuits that have been closed
before client or service sent a single data cell.
\\
\textbf{Benefits:}
This could indicate erroneous, malicious, and non-standard behavior by
HS clients. Learing about any such behaviour would be interesting and
useful to improve hidden-service performance and usability.
\\
\textbf{Risks:}
An adversary at the user's ISP could test to see if a user is attempting
to connect to a hidden service by allowing the connection to proceed until
just before data gets sent, and then killing it by modifying the packet
contents to be garbage. Then he could observe if later any relay reports
a larger-than-expected value for this statistic. This would be more
effective if the user response is immediately to attempt to create new
connections, which would only make the increase in this statistics more
noticeable.


\subsection{Performance-related statistics}

\subsubsection{Time from establishing introduction point to receiving
first client introduction}
\label{subsubsec:time_ip_est_to_introduce1}

\textbf{Details:}
%
Relays report the time between \verb+ESTABLISH_INTRO+ and first
\verb+INTRODUCE1+ cell.
\\
\textbf{Benefits:}
%
This statistic tells us how long it takes for the hidden service to
include a relay in its descriptor and publish that descriptor, and for the
first client to fetch that descriptor and use that relay for its
introduction.
This may not be very useful, but is listed here for completeness.
% [dgoulet]: That would basically leak the RendPostPeriod (if IP changes
% at each upload) of the HS. Not sure how an attacker could use that to
% his/her advantage but to consider.
% [karsten]: again, I think you're wrong about introduction points
% changing at each upload.
% [dgoulet]: Yup, IP do *NOT* change at each upload.
\\
\textbf{Risks:}
%
No obvious risks.

\subsubsection{Time from establishing a rendezvous point to receiving the
server rendezvous} \label{subsubsec:time_rp_to_rend1}

\textbf{Details:}
%
Relays report the time from receiving an \verb+ESTABLISH_RENDEZVOUS+ cell
to receiving the corresponding \verb+RENDEZVOUS1+ cell.
\\
\textbf{Benefits:}
%
The time between receiving an \verb+ESTABLISH_RENDEZVOUS+ cell from the
client and the corresponding \verb+RENDEZVOUS1+ cell from the server tells
us a lot about performance of the rendezvous protocol.
The rendezvous point is the only place in the protocol that witnesses
events near the beginning and near the end of the connection establishment
process.
If we ever want to improve the steps inbetween, this metric is the only
way to measure effectiveness of improvements in the deployed network.
\\
\textbf{Risks:}
%
Again, there are at least no obvious risks from gathering this statistic.

\subsubsection{Time from server rendezvous to first client data}
\label{subsubsec:time_rend1_to_data}

\textbf{Details:}
%
Relays report the time from receiving a \verb+RENDEZVOUS1+ cell to seeing
the first \verb+RELAY+ cell sent from the client.
\\
\textbf{Benefits:}
The time from receiving a \verb+RENDEZVOUS1+ cell from the server (and
relaying it as \verb+RENDEZVOUS2+ cell to the client) and receiving the
first \verb+RELAY+ cell from the client is another performance indicator
of the protocol.
\\
\textbf{Risks:}
%
There are no obvious risks from learning the time between these two
steps in the rendezvous protocol.

\subsection{Failure statistics}

Should we report number and type of failures in the protocol, if these
statistics are not sufficient to actually debug a problem?
Could be a starting point to look at actual logs from relays.
But is this what statistics are for?

\subsubsection{Number of failed attempts to establish an introduction
point} \label{subsubsec:num_failed_ips}

\textbf{Details:}
%
A relay can not decline to be an introduction point.
However, an \verb+ESTABLISH_INTRO+ cell might be malformed (wrong public
key, bad signature, etc...).
The relay would count the number of declined \verb+ESTABLISH_INTRO+ cells
and report them along with the total number of received
\verb+ESTABLISH_INTRO+ cells.
Or it would report successes and failures, rather than totals and
failures.
\\
\textbf{Benefits:}
%
Wrong \verb+ESTABLISH_INTRO+ cells shows either a very bad bug in the code
or a deliberate action (data mangling, unknown attack, DoS, ...).
%
% [dgoulet]: After an IRC discussion with arma and asn, I remember that
% this one could be "cool to have" but without more information that we
% can't collect for privacy reasons, this stat would not help at all in
% the end game. The question remains if we should simply keep it or not
% even if right now we don't see a added value?
% [karsten:] right, this is a fine question, not only limited to this
% statistic.  I added a new paragraph to the section start for "general
% considerations for gathering hidden-service statistics".
\\
\textbf{Risks:}
%
No obvious risks.

\subsubsection{Reasons for terminating established introduction points} \label{subsubsec:reasons_end_ips}

\textbf{Details:}
%
Relays report frequencies of circuit terminations requested by services
vs. different types of failures.
\\
\textbf{Benefits:}
%
If there are more than a small percentage of failures, decide how to make
things more robust.
\\
\textbf{Risks:}
%
No obvious risks.

\subsubsection{Number of descriptors published to the wrong directory} \label{subsubsec:num_descriptors_wrong_hsdir}

\textbf{Details:}
%
A relay reports the number of published descriptors that it is not
responsible for.

\subsubsection{Number of descriptor fetch requests for non-existent
descriptor} \label{subsubsec:num_fetch_nonexistent}

\textbf{Details:}
%
Relays count the number of fetch requests for hidden service identities
they don't have in their cache.
We need to enumerate the reasons why a client would ask for the wrong
descriptor.
(but how do we find out...?)
For example: a) clock sync issues, b) different network view between, c)
``the hidden service hasn't published recently'', d) ``the hidden service
is offline for months''.
\\
\textbf{Benefits:}
%
This seems like a statistic that could potentially find bugs in Tor.
\\
\textbf{Risks:}
%
This statistic could reveal things that we don't really understand and
might reveal information about specific services.



\subsubsection{Number of discarded client introductions by reason} \label{subsubsec:num_discarded_client_intros}

\textbf{Details:}
%
How many \verb+INTRODUCE1+ cells have been discarded because of unknown
service/malformed (?)/whatever-can-go-wrong, by introduction point?
\\
\textbf{Benefits:}
%
Anything exceeding a small portion of discarded \verb+INTRODUCE1+ cells
shows either a very bad bug in the code or a deliberate action (data
mangling, unknown attack, DoS, ...).
%
% [dgoulet]: That is again a "cool to have" stat but not sure how it would
% help us investiguate. It can I guess trigger an alarm but apart from
% that...
% [karsten]: right, see section start.
\\
\textbf{Risks:}
%
No obvious risks.
More precisely, if absolute numbers are reported, the risk is the same as
the risk of reporting the number of received \verb+INTRODUCE1+ cells; if
only fractions are reported, it's not that bad.
%
\subsubsection{Number of server rendezvous with unknown rendezvous cookie} \label{subsubsec:num_server_rend_unknown_cookie}

\textbf{Details:}
%
Relays report the number of \verb+RENDEZVOUS1+ cell with unknown
rendezvous cookie.
\\
\textbf{Benefits:}
%
The number of \verb+RENDEZVOUS1+ cell that cannot be matched with a
previously established rendezvous circuit can be interesting for analyzing
problems in the protocol.
We might even distinguish between rendezvous cookies that were previously
known to the relay and those that seem entirely unrelated.
The benefit gained from this statistic is not huge though.
\\
\textbf{Risk:}
%
No obvious risks.
\end{comment}

\section{Obfuscation methodology} \label{sec:obfuscation}
There is a variety of available methods to produce general
statistics about a dataset without revealing specific sensitive details.
We briefly discuss how this might be done in the context of hidden
services, and then we provide two algorithms for revealing count and
distributional statistics that can be applied to a variety of specific
hidden-service statistics.

Some useful techniques for privately publishing statistics on hidden
services are
\begin{compactitem}
\item Releasing aggregate statistics over time, such as total counts or
averages in a given period
\item Adding noise (i.e. random inaccuracy)
\item Limiting accuracy to a certain granularity via rounding (aka
``binning'')
\item Adding time-delay to the release of statistics such that the output
doesn't reveal information about ongoing activity
\item Using cryptographic techniques to hide the source of information,
such as anonymizing reports from individual relays
\end{compactitem}
However, in general, publishing any information that is broadly
informative might break privacy, because that information may be just what
the adversary needs to know in order to learn a sensitive
fact~\cite{Dwork06differentialprivacy}. Therefore, a discussion of privacy
on Tor should consider plausible background knowledge for an adversary.
We can expect that the adversary may know things such as
\begin{compactitem}
\item The addresses of a large number of publicly-available services
(e.g. by crawling the Web)
\item A minimum amount of traffic received by a given hidden service
(e.g. due to sending that traffic himself)
\item The Introduction Points of a service (e.g. by obtaining the
descriptor)
\item The availability of a service (e.g. by attempting to connect
periodically)
\item Roughly the number of client connections and amount of client
traffic for a service (e.g. a web forum that reveals user activity on the
site)
\end{compactitem}

Given such information, it can be seen that certain statistics cannot be
published by individual relays with reasonable accuracy without violating
some privacy. For example, if each relay accurately reported the number of
client introduction requests it received, then an adversary that
knows the \texttt{.onion} address of a hidden service (and thus can obtain
its Introduction Points) could infer how many client connections the
hidden-service received, especially if there were few other hidden
services sharing its Introduction Points. The general problem is that, for
certain types of hidden-service activities, different hidden services or
clients will make use of different relays in a way that may be known by
the adversary.

\begin{comment}
Table~\ref{table:stats_needing_aggregation} lists
those statistics for which this is an issue.
\begin{table}
\center
\caption{Per-relay statistics at high risk to leak private information}
\label{table:stats_needing_aggregation}
\begin{tabular}{|l|l|}
\hline
\textbf{Description} & \textbf{Section}\\
\hline
Number of descriptor fetch requests &
\ref{subsubsec:num_desc_fetches}\\
\hline
Number of introductions received from clients &
\ref{subsubsec:num_intros_from_clients}\\
\hline
Reasons for terminating established introduction points &
\ref{subsubsec:reasons_end_ips}\\
\hline
Number of discarded client introductions by reason &
\ref{subsubsec:num_discarded_client_intros}\\
\hline
Time from establishing introduction point to tearing down circuit &
\ref{subsubsec:time_intro_to_teardown}\\
\hline
Number of descriptor updates per service &
\ref{subsubsec:num_decriptor_updates}\\
\hline
Time between last and first published descriptor with same identifier &
\ref{subsubsec:time_first_last_descriptor_update}\\
\hline
Number of descriptor fetch requests by service identity &
\ref{subsubsec:num_descriptor_fetches_per_hs}\\
\hline
Number of introductions received by established introduction point &
\ref{subsubsec:num_intros_per_circ}\\
\hline
Time from establishing introduction point to receiving first client 
introduction & \ref{subsubsec:time_ip_est_to_introduce1}\\
\hline
\end{tabular}
\end{table}
\end{comment}

We give two algorithms for privately publishing statistics that do not
have this problem, that is, that can be released by each relay.
Two examples of such statistics are those described by Kadianakis et
al.~\cite{torprop-hsstats} (also mentioned in Section~\ref{sec:protocol}):
\begin{compactenum}
\item \textsf{NumRPCells}: The number of hidden-service data
cells seen at a Rendezvous Point
\item \textsf{NumHSDirIDs}: The number of unique hidden
identifiers seen at an HSDir.
\end{compactenum}
The first algorithm provides a way to
publish statistics that are simple running counts, including both
\textsf{NumRPCells} and \textsf{NumHSDirIDs}. The second algorithm
provides a way to publish statistics about a distribution of values.

Our algorithms will add noise in a way that provides differential
privacy~\cite{dwork-tcc2006} for ``single actions''. What constitutes a
single action will depend on the specific statistic. For example,
Kadianakis et al.~\cite{torprop-hsstats} use the following for their
statistics:
\begin{compactenum}
\item For \textsf{NumRPCells}, a single action is
transferring a fixed amount of data (specifically, 2048 cells). Thus the
added noise obscures the activity of a single service, client, or
connection up to that amount of traffic.
\item For \textsf{NumHSDirIDs}, a single action is
publishing a fixed number of hidden services (specifically, 8). Thus the
added noise obscures the existence of any eight or fewer hidden services.
\end{compactenum}
To obtain differential privacy, our algorithms add noise using the
Laplace distribution, which has a probability distribution function
$\textsf{Lap}(b)$ of $f(x) = e^{-|x|/b}/(2b)$. We will choose $b$ such
that altering a single action will change the probability of the total
output by a factor of at most $e^{\epsilon}$. Thus more privacy is
provided the smaller that $\epsilon$ is.

\subsection{Counts} \label{subsec:counts}
Reporting a basic count is useful in its own right, and it also provides a
simple setting in which to develop privacy-preserving methodology that
we can use for more complicated statistics. Counts can be used to
summarize many types of hidden-service activity, such as the number of
hidden services, the number of hidden-service clients, and the amount of
hidden-service traffic.
\begin{comment}
Table~\ref{table:count_stats} lists the statistics
for which it could be useful to release counts.
\begin{table}
\center
\caption{Count statistics}
\label{table:count_stats}
\begin{tabular}{|l|l|}
\hline
\textbf{Description} & \textbf{Section}\\
\hline
Number of circuits built with TAP vs. nTor &
\ref{subsubsec:num_circ_tap}\\
\hline
Number of established introduction points &
\ref{subsubsec:num_establish_ip}\\
\hline
Number of descriptor publish request &
\ref{subsubsec:num_descriptor_publish}\\
\hline
Number of descriptors with encrypted introduction points &
\ref{subsubsec:num_desc_encrypted_ips}\\
\hline
Number of descriptor fetch requests &
\ref{subsubsec:num_desc_fetches}\\
\hline
Number of established rendezvous points &
\ref{subsubsec:num_rps}\\
\hline
Number of introductions received from clients &
\ref{subsubsec:num_intros_from_clients}\\
\hline
Number of server rendezvous &
\ref{subsubsec:num_server_rendezvous}\\
\hline
Number of closed rendezvous circuits without a single data cell &
\ref{subsubsec:num_rend_circ_no_data}\\
\hline
Number of failed attempts to establish an introduction point &
\ref{subsubsec:num_failed_ips}\\
\hline
Reasons for terminating established introduction points &
\ref{subsubsec:reasons_end_ips}\\
\hline
Number of descriptors published to the wrong directory &
\ref{subsubsec:num_descriptors_wrong_hsdir}\\
\hline
Number of discarded client introductions by reason &
\ref{subsubsec:num_discarded_client_intros}\\
\hline
Number of server rendezvous with unknown rendezvous cookie &
\ref{subsubsec:num_server_rend_unknown_cookie}\\
\hline
\end{tabular}
\end{table}
\end{comment}

To release a single count, we will use ideas from differential privacy
to provide strong protection for a single hidden-service action. However,
we wish to
continually publish statistics over time, and as a result differential
privacy, using a per-user or per-service privacy notion that includes
actions over time, does not provide an adequate solution. The reasons are
(\emph{i}) mechanisms using global sensitivity~\cite{dwork-tcc2006} that
would apply over time require amounts of noise that grow with the
reporting period (potentially years in our case), and (\emph{ii})
improving the accuracy using local mechanisms~\cite{nissim-stoc2007} is
not feasible because the Tor protocol by design hides which activities
correspond to the same user or service.

There are several challenges to privately publishing statistics over time.
One is that, although the effect of a single action may be made difficult
to determine in any given statistic, the collective set of statistics may
reveal some level of activity by the same user or service. This problem
of a single sensitive fact influencing many published statistics
was effectively exploited by Homer et al.~\cite{pgen:homer} to identify
if an individual was a member of a diseased study group based only on 
per-gene statistics (where here data per-gene replace data
per-time-period). Another challenge is that it may be
possible to remove the noise added to the published values if ``fresh''
noise (i.e. noise generated using new randomness) is added to each
statistic. For example, if a count stays the same for a while, and
the adversary knows that (or can guess it with some confidence), then
the adversary can get a good estimate of the count by taking the
mean of the sequence of published noisy counts. Simply reusing the
same noise isn't adequate, however, because in that case the statistics
would reveal with certainty all changes in the statistic and thus
all activity since the fresh noise was chosen.

To handle this problem, we will use simple rounding or ``binning''. This
will hide changes to a count that keep it in the same bin. Of course,
this won't hide the effects of an action if the count happens to be near
the rounding threshold, and also the adversary can in most cases himself
perform actions that alter the count to attempt to determine the location
of the count within the bin. However, we will mitigate both of these
issues by making the bin output itself noisy.

We suggest the following to privately publish a count $c$:
\begin{compactenum}
\item Repeatedly maintain a running count $c$ over a time period of length
$t$.
\item Choose a bin granularity $\delta_1$, which should be large enough
to contain the change in a single statistic due to a \emph{repeated}
action, that is, an action repeated over many
reporting periods that we wish to hide any single instance of.
\item Round $c$ to the nearest multiple of $\delta_1$, that is, let
$\hat{c} = \delta_1[c/\delta_1]$, where $[]$ indicates the nearest integer
function. Rounding up (as in Kadianakis et al.~\cite{torprop-hsstats}) or
down can be performed instead for a similar effect on privacy, although
they introduce a bias that should be corrected
for~\cite{extrapolation-tor-techreport}.
\item Choose a value $\nu$ from the $\textsf{Lap}(\delta_2/\epsilon)$
distribution. $\epsilon$ is the privacy
parameter discussed in Sec.~\ref{sec:obfuscation}.
$\delta_2$ is the amount by which a single (non-persistent) action that
we wish to hide could change the bin center.
\item Let the noisy count be $\tilde{c} = \hat{c} + \nu$.
\item Wait until all activity contributing to count $c$ should have
completed, and then publish $\tilde{c}$.
\end{compactenum}

\paragraph{Example 1:} Kadianakis et al.~\cite{torprop-hsstats} use this
algorithm to publish \textsf{NumRPCells} over periods of length
$t = 24$ hours. The waiting period after collection is implicit in the
length of time until the next extra-info descriptor is published by the
relay, which happens every 18 hours unless certain relay properties
change~\cite{dir-spec}. They use $\delta_1 = 1024$, $\delta_2 = 2048$, and
$\epsilon = 0.3$. This setting of $\delta_1$ hides any repeated transfer
of up to 1024 cells. Tor cells have up to 509 payload
bytes~\cite{tor-spec}, and so this is 509 KiB. This setting of $\delta_2$
hides any group of up to 2048 transferred cells (1018 KiB) (e.g. a
connection in which a client downloads 1 MB). One way of interpreting the
privacy from $\epsilon=0.3$ is from a Bayesian
perspective~\cite{ganta-kdd2008}, where if a priori, for any given set of
other transfers, the adversary believed a given transfer of up to 2048
cells did (or didn't) occur, then the statistics can only increase his
confidence by at most $1-e^{0.3}$ (i.e. $\sim35\%$).

\paragraph{Example 2:} Kadianakis et al.~\cite{torprop-hsstats} use this
algorithm to publish \textsf{NumHSDirIDs} over periods of length
$t = 24$ hours, waiting to publish with the relay's next extra-info
descriptor. They use $\delta_1 = 8$, $\delta_2 = 8$, and
$\epsilon = 0.3$. These settings for $\delta_1$ and $\delta_2$ hide any
single or repeated publication of any given group of at most 8 onion
services (e.g. a set of 8 or fewer related onion addresses that are
aliases for the same onionsite).

\subsection{Distributions} \label{subsec:distributions}
For many statistics, it would be very helpful to understand the
distribution of values. For example, such information about the
number of cells on a single circuit could reveal if most
hidden-service traffic is produced by relatively few connections.
\begin{comment}
Table~\ref{table:dist_stats} lists the statistics for which it could 
be useful to release information about a distribution.
\begin{table}
\center
\caption{Statistics with interesting distributions}
\label{table:dist_stats}
\begin{tabular}{|l|l|}
\hline
\textbf{Description} & \textbf{Section}\\
\hline
Time from circuit extension to circuit purpose change &
\ref{subsubsec:time_circ_ext_to_purpose_change}\\
\hline
Time from circuit purpose change to tearing down circuit &
\ref{subsubsec:time_circ_purpose_change_to_teardown}\\
\hline
Time from establishing introduction point to tearing down circuit &
\ref{subsubsec:time_intro_to_teardown}\\
\hline
Number of descriptor updates per service &
\ref{subsubsec:num_decriptor_updates}\\
\hline
Time between last and first published descriptor with same identifier &
\ref{subsubsec:time_first_last_descriptor_update}\\
\hline
Number of introduction points contained in descriptors &
\ref{subsubsec:num_ips_in_descriptors}\\
\hline
Number of descriptor fetch requests by service identity &
\ref{subsubsec:num_descriptor_fetches_per_hs}\\
\hline
Number of introductions received by established introduction point &
\ref{subsubsec:num_intros_per_circ}\\
\hline
Number of cells sent over rendezvous circuits in either direction &
\ref{subsubsection:num_cells_rend_circ}\\
\hline
Time from first client data to tearing down circuit &
\ref{subsubsec:time_client_data_to_teardown}\\
\hline
Time from establishing introduction point to receiving first client 
introduction & \ref{subsubsec:time_ip_est_to_introduce1}\\
\hline
Time from establishing a rendezvous point to receiving the
server rendezvous & \ref{subsubsec:time_rp_to_rend1}\\
\hline Time from server rendezvous to first client data &
\ref{subsubsec:time_rend1_to_data}\\
\hline
Number of descriptor fetch requests for non-existent descriptor &
\ref{subsubsec:num_fetch_nonexistent}\\
\hline
\end{tabular}
\end{table}
\end{comment}

Following are several potential ways to publish information about a
distribution:
\begin{compactitem}
\item Publish a histogram of possible values (e.g. the number of values in
$[0,1)$, $[1,10)$, $[10, 100)$, and $[100, \infty)$).
\item Publish a subset of percentile values (e.g. quartiles).
\item Publish standard summary statistics, (e.g. mean, variance,
skew, and kurtosis).
\end{compactitem}
To protect individual privacy when releasing these kinds of data,
we would again like to protect activity over time and also provide
particularly-strong protection for a single activity. This is quite 
straightforward to do for publishing
histograms simply by applying the techniques that we have developed for
counts to each
count in the histogram. Thus we suggest using histograms in this way to
report distribution data, as follows:
\begin{compactenum}
\item Choose a finite number $k$ of \emph{buckets} that cover the possible
values of the statistic (we use the term ``buckets'' to distinguish
these from bins that will limit the granularity of each bucket). Each
extra bucket will result in a certain additional amount of noise being
added, but including more values in a bucket (i.e. increasing its width)
reduces its accuracy. Therefore, the number and width of the buckets
should be balanced while also
choosing buckets to capture the most useful distinctions
for the statistic under consideration (e.g. deciding between relative and
absolute accuracy).
\item Over repeated time periods of length $t$, maintain running counts
$c_i$, where $c_i$ is the count of observed values in the $i$th bucket.
\item For the $i$th bucket, the count $c_i$ of values in that bucket
should be rounded to a chosen granularity $\delta_1$:
$\hat{c_i} = \delta_1[c_i/\delta_1]$.
$\delta_1$ should be at least the amount by which a single instance of
a repeated action that we want to hide could change the bucket count,
where again the notion
of a single action depends on the context. The $\delta_1$-sized bins here
serve the same purpose of protecting privacy over time that they did when
publishing a single count.
\item Fresh Laplace noise $\nu_i$ with distribution
$\textsf{Lap}(2\delta_2/\epsilon)$ should be added to the center of the
bin of the $i$th bucket, where $\delta_2$ is at least the amount by which
a single (non-repeated) action that we want to hide could change the bin
center. Let the resulting value be
$\tilde{c_i} = \hat{c_i} + \nu_i$. The value $2$ appears in the Laplace
parameter because modifying a single entry in the
histogram can change two values: the value of the bucket it was changed
from and the value of the bucket it was changed to.
\item Wait until the activity contributing to the histogram should have
completed, and then publish each noisy bucket count,
$\tilde{c_i}$, $1\le i\le k$.
\end{compactenum}

\section{Future Work}
There are many possible ways to expand the hidden-service statistics that
we can safely gather and to improve their accuracy. One promising option
is to securely perform aggregation
such that no single party can learn more than the final aggregate value.
This would allow collecting statistics that cannot be reported by each
relay individually, as previously discussed.

In addition, secure aggregation could reduce the amount of noise that
needs to be added. With per-relay reporting, rounding and noise is
applied to each relay's statistics when using the algorithms described
in Sections~\ref{subsec:counts} \& \ref{subsec:distributions}. However,
the same noise would provide equivalent protection if applied only once
to the statistics after network-wide aggregation. This would reduce
the amount of added noise and rounding inaccuracy by a factor of $m$,
where $m$ is the number of relays.

There are some promising approaches to secure statistics aggregation
including
\begin{compactitem}
\item Have the relays provide inputs to a secure multiparty computation
(SMC) protocol that produces the desired statistics with any
privacy-preserving modifications included (e.g. added
noise)~\cite{privda-acsac2014}.
\item Use a customized aggregation protocol, such at that of Elahi et
al.~\cite{elahi-ccs2014}
\item Anonymize statistics reports, either via Tor itself or via a shuffle
run over a separate set of servers. For statistics that could be
attributable to a small set of relays by their values alone (e.g. a large
number of rendezvous data cells is likely to come from a small set of
large relays), break up the values into minimum amounts.
\end{compactitem}

Adoption of these approaches faces some challenges specific to their use
in Tor. Those  issues and some suggestions for handling them are
\begin{compactenum}
\item Implementation difficulty: Making use of sophisticated
cryptographic tools, such as non-standard cryptosystems or novel
SMC protocols, often requires building secure implementations of
them. This can require significant time and skill. It also
creates future maintenance obligations. When choosing from the above
solutions, we will have to consider what reliable software already exists
for their various cryptographic components.
\item Manipulation of statistics: Adversarial relays may report incorrect
statistics in order to affect the aggregate statistic. For example, a
simple aggregate such as a sum could be trivially destroyed by a malicious
relay reporting a much larger value than its true input. One way to handle
this problem is to use ``robust'' statistics~\cite{dwork-stoc2009}, which
are not excessively influenced by outliers. For example, we could use a
median instead of a mean as the basis for a sum.
\end{compactenum}

\section{Conclusion}
Statistics about the usage and performance of Tor hidden services could
serve many valuable purposes. However, doing so in a privacy-preserving
manner is challenging. We have described the kinds of hidden-service
statistics that Tor relays are in a position to collect and the main
criteria
on which collection procedures should be evaluated. In particular, we have
provided a list of privacy goals for Tor hidden services that goes beyond
simply hiding the server's location. Furthermore, we explored how
statistics might be published in a privacy-preserving way, and we gave two
specific algorithms for publishing broadly useful count and distribution
statistics.

\bibliography{hidden-service-stats}
\end{document}
